<?php
# ***** BEGIN LICENSE BLOCK *****
# This is Visites, a plugin for DotClear. 
# Copyright (c) 2005 k-net. All rights reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

$core->addBehavior('publicPrepend',array('visites','mk_stat'));


// This class is only for getting the URL type before getDocument() is called
class visitesGetUrlType extends urlHandler {
	
	public function getUrlType() {
		global $core;
		
		$this->register('post','post','^post/(.+)$',array('dcUrlHandlers','post'));
		$this->register('category','category','^category/(.+)$',array('dcUrlHandlers','category'));
		$this->register('archive','archive','^archive(/.+)?$',array('dcUrlHandlers','archive'));
		$this->register('feed','feed','^feed/(.+)$',array('dcUrlHandlers','feed'));
		$this->register('trackback','trackback','^trackback/(.+)$',array('dcUrlHandlers','trackback'));
		$this->register('rsd','rsd','^rsd$',array('dcUrlHandlers','rsd'));
		
		$type = $args = '';
		
		if ($core->blog->settings->url_scan == 'path_info') {
			$part = substr($_SERVER['PATH_INFO'],1);
		} else {
			$part = $_SERVER['QUERY_STRING'];
		}
		
		$this->getArgs($part,$type,$args);
		
		if (!$type) {
			return 'default';
		} else {
			return $type;
		}
	}
}

class visites
{
	public static function mk_stat() {
		global $core;
		
		$temp = new visitesGetUrlType();
		$urlType = $temp->getUrlType();
		unset($temp);
		
		if ($urlType != 'feed' && $urlType != 'rsd') {
			
			$count = array('once' => 0, 'session' => 0, 'all' => 0);
			if (null !== $core->blog->settings->get('visites_countonce')) {
				$count['once'] = $core->blog->settings->visites_countonce;
			}
			if (null !== $core->blog->settings->get('visites_countsession')) {
				$count['session'] = $core->blog->settings->visites_countsession;
			}
			if (null !== $core->blog->settings->get('visites_countall')) {
				$count['all'] = $core->blog->settings->visites_countall;
			}
			
			if (empty($GLOBALS['visites'])) { // Avoid double or more count in one page
				if (!isset($_COOKIE['dc_visites_nevercountme'])) {
					
					// Count 'once' visitors
					if (!isset($_COOKIE['dc_visites_countonce_tm'])) {
						$count['once']++;
						setcookie('dc_visites_countonce_tm', time(), time()+365*24*3600, '/');
					}
					// Count 'session' visitors
					if (!isset($_COOKIE['dc_visites_countsession_tm'])) {
						$count['session']++;
						setcookie('dc_visites_countsession_tm', time(), null, '/');
					}
					// Count 'all' visitors
					$count['all']++;
					
				}
				
				$GLOBALS['visites'] = array();
				$GLOBALS['visites']['count'] = array();
				$GLOBALS['visites']['count']['once'] = (string) $count['once'];
				$GLOBALS['visites']['count']['session'] = (string) $count['session'];
				$GLOBALS['visites']['count']['all'] = (string) $count['all'];
				
				$core->blog->settings->setNamespace('visites');
				$core->blog->settings->put('visites_countonce',$count['once'],'int');
				$core->blog->settings->put('visites_countsession',$count['session'],'int');
				$core->blog->settings->put('visites_countall',$count['all'],'int');
				$core->blog->triggerBlog();
			}
		}
		return true;
	}
}

class tplVisites
{
	public static function visitesWidget($w) {
		global $core;
		
		if ((!empty($GLOBALS['visites']['count']) || null !== $core->blog->settings->get('visites_countall')) && !($w->homeonly && $core->url->type != 'default')) {
				if (!empty($GLOBALS['visites']['count'])) {
					$count = $GLOBALS['visites']['count'];
				} else {
					$count = array('once' => 0, 'session' => 0, 'all' => 0);
					if (null !== $core->blog->settings->get('visites_countonce')) {
						$count['once'] = $core->blog->settings->visites_countonce;
					}
					if (null !== $core->blog->settings->get('visites_countsession')) {
						$count['session'] = $core->blog->settings->visites_countsession;
					}
					if (null !== $core->blog->settings->get('visites_countall')) {
						$count['all'] = $core->blog->settings->visites_countall;
					}
				}
				
				
				$title = $w->title ? $w->title : __('Visites');
				$text = $w->text ? $w->text : '';
				if (!$w->dontescapehtml) {
					$title = html::escapeHTML($title);
					$text = '<p>'.html::escapeHTML($text).'</p>';
				}
				$text = str_replace("\n", '<br />', str_replace("\r", '<br />', str_replace("\r\n", '<br />', $text)));
				$nbdigits = $w->nbdigits ? $w->nbdigits : 0;
				$nbdigits = array('once' => $nbdigits, 'session' => $nbdigits, 'all' => $nbdigits);
				$countername = $w->countername ? $w->countername : null;
				
				if (!empty($countername) && $countername != 'text') {
					if (is_nan($nbdigits['once']) || $nbdigits['once'] < strlen($count['once'])) {
						$nbdigits['once'] = strlen($count['once']);
					} else {
						while (strlen($count['once']) < $nbdigits['once']) {
							$count['once'] = '0'.$count['once'];
						}
					}
					if (is_nan($nbdigits['session']) || $nbdigits['session'] < strlen($count['session'])) {
						$nbdigits['session'] = strlen($count['session']);
					} else {
						while (strlen($count['session']) < $nbdigits['session']) {
							$count['session'] = '0'.$count['session'];
						}
					}
					if (is_nan($nbdigits['all']) || $nbdigits['all'] < strlen($count['all'])) {
						$nbdigits['all'] = strlen($count['all']);
					} else {
						while (strlen($count['all']) < $nbdigits['all']) {
							$count['all'] = '0'.$count['all'];
						}
					}
					$counttext = array('once' => '', 'session' => '', 'all' => '');
					for ($i = $nbdigits['once'] - 1; $i >= 0; $i--) {
						$counttext['once'] = '<img src="index.php?pf=visites/counters/'.html::escapeHTML($countername).'/'.$count['once']{$i}.'.png" alt="'.$count['once']{$i}.'" />'.$counttext['once'];
					}
					for ($i = $nbdigits['session'] - 1; $i >= 0; $i--) {
						$counttext['session'] = '<img src="index.php?pf=visites/counters/'.html::escapeHTML($countername).'/'.$count['session']{$i}.'.png" alt="'.$count['session']{$i}.'" />'.$counttext['session'];
					}
					for ($i = $nbdigits['all'] - 1; $i >= 0; $i--) {
						$counttext['all'] = '<img src="index.php?pf=visites/counters/'.html::escapeHTML($countername).'/'.$count['all']{$i}.'.png" alt="'.$count['all']{$i}.'" />'.$counttext['all'];
					}
				} else {
					$counttext = $count;
				}
				
				$title = str_replace('%CA', $counttext['all'], str_replace('%CS', $counttext['session'], str_replace('%CO', $counttext['once'], $title)));
				
				if (!empty($text)) {
					$text = str_replace('%CA', $counttext['all'], str_replace('%CS', $counttext['session'], str_replace('%CO', $counttext['once'], $text)));
					
					return
					"\n".
					'<div id="visites">'.
					'<h2>'.$title.'</h2>'.
					$text.
					'</div>'."\n";
				} else {
					return
					"\n".
					'<div id="visites">'.
					'<h2>'.$title.'</h2>'.
					'</div>'."\n";
				}
		} else {
			return;
		}
	}
	
}
?>